## ayatana-indicator-messages 24.5.1

=== CMakeLists.txt ===
project(ayatana-indicator-messages C CXX)
cmake_minimum_required(VERSION 3.13)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# Globals

set(PROJECT_VERSION "24.5.1")
set(PACKAGE ${CMAKE_PROJECT_NAME})
set(GETTEXT_PACKAGE "ayatana-indicator-messages")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "..." FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Options

option(ENABLE_TESTS "Enable all tests and checks" OFF)
option(ENABLE_COVERAGE "Enable coverage reports (includes enabling all tests and checks)" OFF)
option(ENABLE_WERROR "Treat all build warnings as errors" OFF)

if(ENABLE_COVERAGE)
    set(ENABLE_TESTS ON)
    set(CMAKE_BUILD_TYPE "Coverage")
else()
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(ENABLE_WERROR)
    add_definitions("-Werror")
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    add_definitions("-Weverything")
else()
    add_definitions("-Wall")
endif()

#  Check for prerequisites

include (GNUInstallDirs)
find_package(PkgConfig REQUIRED)
include(FindPkgConfig)

pkg_check_modules(
    PROJECT_DEPS
    REQUIRED
    glib-2.0>=2.36
    gio-unix-2.0>=2.36
    accountsservice
)

# Cppcheck

add_custom_target(
    cppcheck
    COMMAND
    cppcheck
    --enable=all
    -q
    --error-exitcode=2
    --inline-suppr
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/tests
)

# Build

add_subdirectory(src)
add_subdirectory(libmessaging-menu)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(doc)

# Testing and coverage

if (ENABLE_TESTS)
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
    if (ENABLE_COVERAGE)
        find_package(CoverageReport)
        ENABLE_COVERAGE_REPORT(
            TARGETS "messaging-menu" "indicator-messages-service"
            TESTS ${COVERAGE_TEST_TARGETS}
            FILTER /usr/include ${CMAKE_BINARY_DIR}/*
        )
    endif ()
endif ()

# Display config info

message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Unit tests: ${ENABLE_TESTS}")
message(STATUS "Build with -Werror: ${ENABLE_WERROR}")

=== data/CMakeLists.txt ===
# org.ayatana.indicator.session.gschema.xml

find_package(GSettings)
add_schema("org.ayatana.indicator.messages.gschema.xml")

# ayatana-indicator-messages.service

pkg_check_modules(SYSTEMD systemd)

if (${SYSTEMD_FOUND})
    pkg_get_variable(SYSTEMD_USER_DIR systemd systemduserunitdir)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ayatana-indicator-messages.service.in" "${CMAKE_CURRENT_BINARY_DIR}/ayatana-indicator-messages.service" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ayatana-indicator-messages.service" DESTINATION "${SYSTEMD_USER_DIR}")
endif()

# ayatana-indicator-messages.desktop

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ayatana-indicator-messages.desktop.in" "${CMAKE_CURRENT_BINARY_DIR}/ayatana-indicator-messages.desktop" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ayatana-indicator-messages.desktop" DESTINATION "${CMAKE_INSTALL_FULL_SYSCONFDIR}/xdg/autostart")

# org.ayatana.indicator.messages

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/org.ayatana.indicator.messages" DESTINATION "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ayatana/indicators")

# icons/*

install(
    DIRECTORY
    icons/16x16
    icons/22x22
    icons/24x24
    icons/32x32
    icons/48x48
    icons/scalable
    DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor"
    FILES_MATCHING PATTERN "*.png" PATTERN "*.svg"
)

=== libmessaging-menu/CMakeLists.txt ===
# messaging-menu.pc

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/messaging-menu.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/messaging-menu.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/messaging-menu.pc" DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")

# messaging-menu-app.h
# messaging-menu-message.h
# messaging-menu.h

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/messaging-menu-app.h" DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/messaging-menu")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/messaging-menu-message.h" DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/messaging-menu")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/messaging-menu.h" DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/messaging-menu")

# libmessaging-menu.so

set(
    SOURCES
    messaging-menu-app.c
    messaging-menu-message.c
)

set(
    SOURCES_GEN
    ${CMAKE_BINARY_DIR}/src/indicator-messages-service.c
    ${CMAKE_BINARY_DIR}/src/indicator-messages-application.c
)

set_source_files_properties(${SOURCES_GEN} PROPERTIES GENERATED TRUE)
add_library("messaging-menu" SHARED ${SOURCES} ${SOURCES_GEN})
set_target_properties("messaging-menu" PROPERTIES VERSION 0.0.0 SOVERSION 0)
target_include_directories("messaging-menu" PUBLIC ${PROJECT_DEPS_INCLUDE_DIRS} "${CMAKE_BINARY_DIR}/src")
target_link_options("messaging-menu" PRIVATE "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/messaging-menu.symbols")
target_link_libraries("messaging-menu" ${PROJECT_DEPS_LIBRARIES})
add_dependencies("messaging-menu" "ayatana-indicator-messages-service")
install(TARGETS "messaging-menu" DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}")

# MessagingMenu-1.0.gir

find_package(GObjectIntrospection REQUIRED)

set(
    HEADERS
    messaging-menu-app.h
    messaging-menu-message.h
)

add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.gir"
    DEPENDS "messaging-menu"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND
    ${INTROSPECTION_SCANNER}
    ${HEADERS} ${SOURCES}
    --namespace=MessagingMenu
    --nsversion=1.0
    --quiet
    --warn-all
    --include=GObject-2.0
    --include=Gio-2.0
    --pkg-export=messaging-menu
    --library="messaging-menu"
    --c-include="messaging-menu.h"
    --library-path=${CMAKE_CURRENT_BINARY_DIR}
    --output "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.gir"
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.gir" DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/gir-1.0")

# MessagingMenu-1.0.typelib

add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.typelib"
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.gir"
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND
    ${INTROSPECTION_COMPILER}
    --includedir=${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.gir
    -o "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.typelib"
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.typelib" DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/girepository-1.0")

# MessagingMenu-1.0.vapi

find_package(Vala REQUIRED)

add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.vapi"
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.typelib"
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND
    ${VAPI_GEN}
    --library=MessagingMenu-1.0
    --pkg gio-2.0
    MessagingMenu-1.0.gir
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.vapi" DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/vala/vapi")

add_custom_target("libmessaging-menu" ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/MessagingMenu-1.0.vapi")

=== src/CMakeLists.txt ===
include(GdbusCodegen)
set(SOURCES_GEN)

# indicator-messages-service.h
# indicator-messages-service.c

add_gdbus_codegen_with_namespace(
    SOURCES_GEN indicator-messages-service
    org.ayatana.indicator.messages
    IndicatorMessages
    ${CMAKE_SOURCE_DIR}/common/org.ayatana.indicator.messages.service.xml
)

# indicator-messages-application.h
# indicator-messages-application.c

add_gdbus_codegen_with_namespace(
    SOURCES_GEN indicator-messages-application
    org.ayatana.indicator.messages
    IndicatorMessages
    ${CMAKE_SOURCE_DIR}/common/org.ayatana.indicator.messages.application.xml
)

# ayatana-indicator-messages-service

set(
    SOURCES
    gactionmuxer.c
    gsettingsstrv.c
    im-accounts-service.c
    im-application-list.c
    im-desktop-menu.c
    im-menu.c
    im-phone-menu.c
    indicator-desktop-shortcuts.c
    messages-service.c
)

add_executable("ayatana-indicator-messages-service" ${SOURCES} ${SOURCES_GEN})
target_compile_definitions(
    "ayatana-indicator-messages-service" PUBLIC
    G_LOG_DOMAIN="Ayatana-Indicator-Messages"
    GETTEXT_PACKAGE="${GETTEXT_PACKAGE}"
    LOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
)
target_include_directories("ayatana-indicator-messages-service" PUBLIC ${PROJECT_DEPS_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries("ayatana-indicator-messages-service" ${PROJECT_DEPS_LIBRARIES})
install(TARGETS "ayatana-indicator-messages-service" RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/ayatana-indicator-messages")

=== tests/CMakeLists.txt ===
# libindicator-messages-service

find_package(GMock)

set(
    HEADERS
    ${CMAKE_SOURCE_DIR}/src/gactionmuxer.h
    ${CMAKE_SOURCE_DIR}/src/dbus-data.h
)

set(
    SOURCES
    ${CMAKE_SOURCE_DIR}/src/gactionmuxer.c
)

set(
    HEADERS_GEN
    ${CMAKE_BINARY_DIR}/src/indicator-messages-service.h
)

set(
    SOURCES_GEN
    ${CMAKE_BINARY_DIR}/src/indicator-messages-service.c
)

set_source_files_properties(${HEADERS_GEN} ${SOURCES_GEN} PROPERTIES GENERATED TRUE)
add_library("indicator-messages-service" STATIC ${HEADERS} ${HEADERS_GEN} ${SOURCES} ${SOURCES_GEN})
target_include_directories("indicator-messages-service" PUBLIC ${PROJECT_DEPS_INCLUDE_DIRS})
target_compile_definitions("indicator-messages-service" PUBLIC G_LOG_DOMAIN="Ayatana-Indicator-Messages")
add_dependencies("indicator-messages-service" "ayatana-indicator-messages-service")

# test-gactionmuxer

add_executable("test-gactionmuxer" test-gactionmuxer.cpp)
target_include_directories("test-gactionmuxer" PUBLIC ${PROJECT_DEPS_INCLUDE_DIRS} "${CMAKE_SOURCE_DIR}/src")
target_link_libraries("test-gactionmuxer" "indicator-messages-service" ${PROJECT_DEPS_LIBRARIES} ${GTEST_LIBRARIES} ${GTEST_BOTH_LIBRARIES} ${GMOCK_LIBRARIES})
add_test("test-gactionmuxer" "test-gactionmuxer")
add_dependencies("test-gactionmuxer" "indicator-messages-service")
set(COVERAGE_TEST_TARGETS ${COVERAGE_TEST_TARGETS} "test-gactionmuxer" PARENT_SCOPE)

if (ENABLE_COVERAGE)
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        target_link_libraries("test-gactionmuxer" "--coverage")
    else()
        target_link_libraries("test-gactionmuxer" "-lgcov")
    endif()
endif()

# gschemas.compiled

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES gschemas.compiled)
set_source_files_properties(gschemas.compiled GENERATED)
execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} gio-2.0 --variable glib_compile_schemas OUTPUT_VARIABLE COMPILE_SCHEMA_EXECUTABLE OUTPUT_STRIP_TRAILING_WHITESPACE)
add_custom_command(OUTPUT gschemas.compiled COMMAND cp -f ${CMAKE_SOURCE_DIR}/data/org.ayatana.indicator.messages.gschema.xml ${CMAKE_CURRENT_BINARY_DIR} COMMAND ${COMPILE_SCHEMA_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR})
add_custom_target("gschemas-compiled" ALL DEPENDS gschemas.compiled)

# indicator-test

pkg_check_modules(DBUSTEST REQUIRED dbustest-1)
add_executable("indicator-test" indicator-test.cpp)
target_include_directories("indicator-test" PUBLIC ${PROJECT_DEPS_INCLUDE_DIRS} ${DBUSTEST_INCLUDE_DIRS} "${CMAKE_SOURCE_DIR}/libmessaging-menu")
target_link_libraries("indicator-test" "messaging-menu" ${PROJECT_DEPS_LIBRARIES} ${DBUSTEST_LIBRARIES} ${GTEST_LIBRARIES} ${GTEST_BOTH_LIBRARIES} ${GMOCK_LIBRARIES})
target_compile_definitions(
    "indicator-test"
    PUBLIC
    INDICATOR_MESSAGES_SERVICE_BINARY="${CMAKE_BINARY_DIR}/src/ayatana-indicator-messages-service"
    SCHEMA_DIR="${CMAKE_CURRENT_BINARY_DIR}"
    XDG_DATA_DIRS="${CMAKE_CURRENT_SOURCE_DIR}"
)
add_test("indicator-test" "indicator-test")
add_dependencies("indicator-test" "messaging-menu" "gschemas-compiled")
set(COVERAGE_TEST_TARGETS ${COVERAGE_TEST_TARGETS} "indicator-test" PARENT_SCOPE)

# test-client.sh

set_source_files_properties("${CMAKE_CURRENT_BINARY_DIR}/test-client.sh" GENERATED)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/test-client.sh" "export LD_LIBRARY_PATH=\"${CMAKE_BINARY_DIR}/libmessaging-menu\"; export GI_TYPELIB_PATH=\"${CMAKE_BINARY_DIR}/libmessaging-menu\"; export XDG_DATA_DIRS=\"${CMAKE_CURRENT_SOURCE_DIR}\"; python3 \"${CMAKE_CURRENT_SOURCE_DIR}/test-client.py\"")
add_test(NAME "test-client" COMMAND sh "${CMAKE_CURRENT_BINARY_DIR}/test-client.sh")

=== debian/changelog ===
ayatana-indicator-messages (24.5.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + White-space fixes.
    + Update copyright attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 12 Mar 2025 13:15:38 +0100

=== debian/control ===
Source: ayatana-indicator-messages
Section: gnome
Priority: optional
Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Debian UBports Team <team+ubports@tracker.debian.org>,
Build-Depends: cmake,
               cmake-extras,
               debhelper-compat (= 13),
               dh-exec,
               gobject-introspection,
               gtk-doc-tools,
               intltool,
               libaccountsservice-dev,
               libdbustest1-dev,
               libgirepository1.0-dev,
               libgtest-dev,
               python3-dbusmock,
               valac,
               systemd-dev [linux-any],
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/AyatanaIndicators/ayatana-indicator-messages
Vcs-Git: https://salsa.debian.org/debian-ayatana-team/ayatana-indicator-messages.git
Vcs-Browser: https://salsa.debian.org/debian-edu-ayatana-team/ayatana-indicator-messages

Package: ayatana-indicator-messages
Architecture: any
Depends: ayatana-indicator-common (>= 0.8.0),
         ${shlibs:Depends},
         ${misc:Depends},
         libglib2.0-bin,
Suggests: indicator-applet | indicator-renderer | mate-applet-indicator,
Breaks: indicator-messages,
Replaces: indicator-messages,
Description: Ayatana Indicator that collects messages that need a response
 A place on the user's desktop that collects messages that need a response.
 .
 This menu provides a condensed and collected view of all of those messages
 for quick access, but without making them annoying in times that you want
 to ignore them.
 .
 Ayatana Indicators are only available on desktop environments that
 provide a renderer for system indicators (such as MATE, Xfce, Lomiri,
 etc.).

Package: libmessaging-menu0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: Ayatana Messaging Menu - shared library
 A place on the user's desktop that collects messages that need a response.
 .
 This menu provides a condensed and collected view of all of those messages
 for quick access, but without making them annoying in times that you want
 to ignore them.
 .
 This library contains information to build status providers to go into
 the messaging menu.

Package: libmessaging-menu-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         gir1.2-messagingmenu-1.0 (=${binary:Version}),
         libmessaging-menu0 (=${binary:Version}),
         libglib2.0-dev,
Description: Ayatana Messaging Menu - library development files
 A place on the user's desktop that collects messages that need a response.
 .
 This menu provides a condensed and collected view of all of those messages
 for quick access, but without making them annoying in times that you want
 to ignore them.
 .
 This package provides development files for the Messaging Menu shared
 library.

Package: gir1.2-messagingmenu-1.0
Section: introspection
Architecture: any
Depends: ${misc:Depends},
         ${gir:Depends},
Description: Ayatana Messaging Menu - gir bindings
 A place on the user's desktop that collects messages that need a response.
 .
 This menu provides a condensed and collected view of all of those messages
 for quick access, but without making them annoying in times that you want
 to ignore them.
 .
 This package can be used by other packages using the GIRepository format
 to generate dynamic bindings.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://releases.ayatana-indicators.org/source/ayatana-indicator-messages/ayatana-indicator-messages-(.+)\.tar\.gz
